# ==================================================================
# Plugins::Recommend_It - Auto Generated Install Module
#
#   Plugins::Recommend_It
#   Author  : Andy Newby (UltraNerds)
#   Version : 3.5.1
#   Updated : Fri 17th May 2007
#
# ==================================================================
#

package Plugins::Recommend_It;
# ==================================================================
    use strict;
    use vars  qw/$VERSION $DEBUG $NAME $META/;
    use GT::Base;
    use GT::Plugins qw/STOP CONTINUE/;
    use Links qw/$CFG $IN $DB/;

    $VERSION = '3.5.1';
    $DEBUG   = 0;
    $NAME    = 'Recommend_It';
# Inhert from base class for debug and error methods
    @Plugins::Recommend_It::ISA = qw(GT::Base);

    $META = {
    'prog_ver' => '3.0.4',
    'url' => 'http://www.ultranerds.com',
    'license' => 'Freeware',
    'description' => 'This plugin will enable you to let your user\'s recommend a link to their friends. New feature includes basic stats, of who they are refering, and when.',
    'author' => 'Andy Newby (UltraNerds)',
    'version' => '3.5.1'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'Hope you enjoy this plugin.';

    return $inst_msg;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'Sorry to see you are uninstalling.';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Recommend_It::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_menu ( 'Recommend_It', [ ['Readme', 'admin.cgi?do=plugin&plugin=Recommend_It&func=Readme'] ] );
    $mgr->install_menu ( 'Recommend_It', [ ['View Stats', 'admin.cgi?do=plugin&plugin=Recommend_It&func=ViewStats'] ] );
    $mgr->install_menu ( 'Recommend_It', [ ['Setup', 'admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=Recommend_It'] ] );
    $mgr->install_options ( 'Recommend_It', [ ['UserRequired', '1', 'Set this to \'yes\' if you want to make a user login before they can recommend a link. Set to \'No\' if you don\'t want them to have to login.', 'SELECT', ['Yes','No'], ['1','0'], '' ] ] );

# Silence warnings
    $GT::Tar::error ||= '';

# The following section will unarchive attached files into the 
# proper location.
    my $file;

   # create the table for news...
   my $creator = $DB->creator('Rec_Stats');  

   $creator->cols ( 
                          ID => { 
                                      pos => 1,
                                      type => 'INT',
                                      size => 40,
                                      not_null => 1
                          },
                          IP => {
                                      pos =>  2,
                                      type => 'TEXT',
                                      size =>  50,
                                      not_null => 0
                          },
                          SenderName => {
                                      pos =>  2,
                                      type => 'TEXT',
                                      size =>  50,
                                      not_null => 1
                          },
                          SenderEmail => {
                                      pos =>  2,
                                      type => 'TEXT',
                                      size =>  50,
                                      not_null => 1
                          },
                          SentList => {
                                      pos =>  2,
                                      type => 'CHAR',
                                      size =>  255,
                                      not_null => 1
                          },
                          Date => {
                                      pos =>  2,
                                      type => 'TEXT',
                                      size =>  50,
                                      not_null => 1
                          }
                      );

  # set as primart key, for the date...  
      $creator->pk ('ID');
      $creator->ai ('ID');
        
       my ($error, $message);    
    
	if (! $creator->create()) { 
		    $GT::SQL::errcode ||= ''; #silence -w
		    $GT::SQL::errcode eq 'TBLEXISTS' ? 
             ($message = "Could not create table <B>Rec_Stats</B> (table already exists)\n") :
				 		 ($error   = "Could not create table <B>Rec_Stats</B>: $GT::SQL::error)"); 
		
	};
	
################################################################################	

# Copying recommend_it.cgi to $CFG->{admin_root_path}/.. directory.
    $file = $tar->get_file ('recommend_it.cgi');

# Get the entire code as a string. 
    my $code = $file->body_as_string; 

# Do some substitutions. 
    $code =~ s/^#!(.*)/#!$CFG->{path_to_perl}/; 
    $code =~ s/use lib '';/use lib '$CFG->{admin_root_path}';/; 
    $code =~ s,Links::init\(\),Links::init('$CFG->{admin_root_path}'),;

# Update the file to the new body. 
    $file->body ($code); 
    $file->name("$CFG->{admin_root_path}/../recommend_it.cgi");

# Chmod the cgi-bin to 777 so we can write to it.
    if (-e "$CFG->{admin_root_path}/../recommend_it.cgi") {
       chmod(0666, "$CFG->{admin_root_path}/../recommend_it.cgi");
    }
    chmod(0777, "$CFG->{admin_root_path}/../");
    $file->write or return Plugins::Recommend_It->error("Unable to extract file: '$CFG->{admin_root_path}/../recommend_it.cgi' ($GT::Tar::error)", 'WARN');
    chmod(0755, "$CFG->{admin_root_path}/../recommend_it.cgi");
    chmod(0755, "$CFG->{admin_root_path}/../"); # set back to 755, otherwise some servers get 500 errors!

    print_it("Setup recommend_it.cgi...");
    
################################################################################    
    
# The following section will unarchive attached files into the 
# proper location.
    my $file;

	  my @files =   ('recommend_it_form.html', 
		         'recommend_it_sent.html');

    for my $html (@files) {
	    
          # if templates already exist... get rid of em!
           if (-e "$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html") { system("rm -f $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html"); }

           $file = $tar->get_file ($html);
           $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html") or return Plugins::Recommend_It->error("Error: $GT::Tar::error");
           unless ($file->write) {
          		last;
	          	return Plugins::Recommend_It->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html' ($GT::Tar::error)", 'WARN');
  	       }
     } # end 'for'

     print_it("Extracted Templates...");    




     my @files =   ('recommend_email_text.html',
                    'recommend_email_html.html');

    for my $html (@files) {
	    
          my $write_name = $html;
	     $write_name =~ s|\Q.html|.eml|;

          # if templates already exist... get rid of em!
           if (-e "$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html") { system("rm -f $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html"); }

           $file = $tar->get_file ($html);
           $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$write_name") or return Plugins::Recommend_It->error("Error: $GT::Tar::error");
           unless ($file->write) {
          		last;
	          	return Plugins::Recommend_It->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/$html' ($GT::Tar::error)", 'WARN');
  	       }
     } # end 'for'

     print_it("Extracted Templates...");    
    

# Create a new column in Links to track down the times that a link is sent
    my $table		= $DB->table('Links');
    my %cols		= $table->cols;

    my $column_name	= 'Recommend_Count';

	if (!(exists $cols{$column_name})) { 
		my $editor = $DB->editor('Links');
		unless ($editor->add_col($column_name, {
							size => 11,
							viewsize => 10,
							type=>'int'}
					) ) {
			$Plugins::Recommend_It::error = "Unable to add column $column_name to Links: $GT::SQL::error";
			return;
		} 
		$table->update({ $column_name => 0 });
	} 
	else {
       $message = "Unable to add column to Links, column already exists";
    }

   # show the error message if we have one...
    if ($message) {
       return "The plugin has been installed, but there were the following warnings: <br><br>$message";
    }    

    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Recommend_It::error
#
    my $mgr = shift;
    
    $mgr->uninstall_menu ( 'Recommend_It', [ ['Readme', 'admin.cgi?do=plugin&plugin=Recommend_It&func=Readme'] ] );
    $mgr->uninstall_menu ( 'Recommend_It', [ ['Setup', 'admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=Recommend_It'] ] );
    $mgr->uninstall_menu ( 'Recommend_It', [ ['View Stats', 'admin.cgi?do=plugin&plugin=Recommend_It&func=ViewStats'] ] );
    $mgr->uninstall_options ( 'Recommend_It', [ ['UserRequired', '1', 'Set this to \'yes\' if you want to make a user login before they can recommend a link. Set to \'No\' if you don\'t want them to have to login.', 'SELECT', ['Yes','No'], ['1','0'], '' ] ] );
    ;
    return "The plugin has been successfully removed!";
}

sub print_it {

   my $msg  = $_[0];
   my $color= $_[1] || 'black';

   print "<font face=\"Tahoma\" size=1 color=\"$color\">$msg</font><BR>";

}

1;